/* 
 *  ============================================================================
 *  TestBuilderPattern.java: Use builder pattern to assemble a car and motorcyle
 *  ============================================================================
 */ 

package builder02;

public class TestBuilderPattern {
   public static void main(String[] args) {

      System.out.printf("Test Builder Pattern ...\n");
      System.out.printf("========================================== ...\n");

      // Create construction director ...

      System.out.printf("--- Create director ...\n");

      Director director = new Director();

      // Create shell car and motorcycle objects ...

      System.out.printf("--- Create shell car and motorcycle objects ...\n");

      Builder fordCar        = new Car("Ford");
      Builder hondaMotorycle = new MotorCycle("Honda");

      // Making Car

      System.out.printf("--- Director constructs car ...\n");

      director.construct( fordCar );

      // Making MotorCycle

      System.out.printf("--- Director constructs motorcycle ...\n");

      director.construct( hondaMotorycle );

      // Retrieve and show car ... 

      System.out.printf("--- \n");
      System.out.printf("--- Retrieve and show car ...\n");
      System.out.printf("--- \n");

      Product p1 = fordCar.getVehicle();
      p1.showProduct();

      // Retrieve and show motorcycle ... 

      System.out.printf("--- \n");
      System.out.printf("--- Retrieve and show car ...\n");
      System.out.printf("--- \n");

      Product p2 = hondaMotorycle.getVehicle();
      p2.showProduct();

      System.out.printf("========================================== ...\n");
   }
}
