/* 
 *  ============================================================================
 *  ModifiedBuilder.java: Common interface.
 * 
 *  Note.  All these methods return type is ModifiedBuilder.
 *         This will help us to apply method chaining ....
 * 
 *  ============================================================================
 */ 

package builder03;

public interface ModifiedBuilder {
   ModifiedBuilder startUpOperations(String startUpMessage);
   ModifiedBuilder buildBody( String bodyType );
   ModifiedBuilder insertWheels( int noOfWheels );
   ModifiedBuilder addHeadlights( int noOfHeadLights );
   ModifiedBuilder endOperations( String endOperationsMessage );
   ProductClass constructCar();         // Assemble the car ...
   ProductClass getConstructedCar();    // Retrieve the constructed object ...
}
