/* 
 *  =========================================================================
 *  EmailErrorHandler.java: ....
 *  =========================================================================
 */ 

package chain01;

public class EmailErrorHandler implements Receiver {
   private Receiver nextReceiver;

   @Override
   public void nextErrorHandler(Receiver nextReceiver) {
      this.nextReceiver = nextReceiver;
   }

   @Override
   public boolean handleMessage(Message message) {
      if (message.text.contains("Email")) {
         System.out.printf("--- Processed by EmailErrorHandler ... \n");
         System.out.printf("---   Message priority: %s ...\n", message.priority );
         System.out.printf("---   Message text: %s ...\n", message.text );
         return true;
      } else {
         if (nextReceiver != null)
             nextReceiver.handleMessage(message);
      }
      return false;
   }
}

