/*
 * =============================================================================
 * TestComposite.java: Create and print hierarchy of spaces and furniture items.
 * =============================================================================
 */

package composite01;
   
public class TestComposite {
   public static void main(String[] args) {
 
      // Initialize three composite graphics

      CompositeHierarchy office    = new CompositeHierarchy("Office");
      CompositeHierarchy workspace = new CompositeHierarchy("Workspace");
 
      // Create table and chairs ...

      Table    desk = new Table("Office Desk");
      Chair chair01 = new Chair("Office Chair");
      Chair chair02 = new Chair("Customer Chair");

      // Add chair and table to the workspace ...

      workspace.add( chair01 );
      workspace.add( desk );

      // Add customer chair and workspace to the office space ...

      office.add( chair02 );
      office.add( workspace );

      // Traverse hierarchy ...

      office.print();
   }
}
