/* 
 *  ==========================================================
 *  Box.java: Draw box component ....
 *  ==========================================================
 */ 

package composite02;

import java.awt.*;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.*;
import java.awt.Point;
import javax.swing.*;

public class Box implements Graphic {
    int iX, iY;
    int iWidth, iHeight;

    public Box ( int iX, int iY, int iWidth, int iHeight ) {
       this.iX = iX;
       this.iY = iY;
       this.iWidth  = iWidth;
       this.iHeight = iHeight;
    }

    public void draw( Graphics2D g2D ) {
       g2D.setColor( Color.black );
       g2D.draw( new Line2D.Double( iX, iY, iX + iWidth,  iY ));
       g2D.draw( new Line2D.Double( iX, iY, iX, iY + iHeight ));
       g2D.draw( new Line2D.Double( iX, iY + iHeight, iX + iWidth, iY + iHeight ));
       g2D.draw( new Line2D.Double( iX + iWidth,  iY, iX + iWidth, iY + iHeight ));
    }
}
 
