/*
 *  ==================================================================
 *  ApplicationMediator.java:
 *  ==================================================================
 */

package mediator01;

import java.util.ArrayList;

public class ApplicationMediator implements Mediator {
   private ArrayList<AbstractColleague> colleagues;

   public ApplicationMediator() {
      colleagues = new ArrayList<AbstractColleague>();
   } 

   public void addColleague( AbstractColleague colleague ) {
      colleagues.add(colleague);
   }

   // Let all other screens know about a new message ...

   public void send( String message, AbstractColleague originator ) {
      for(AbstractColleague colleague: colleagues) {

          // No need to tell ourselves

          if( colleague != originator) {
              colleague.receive(message);
          }
      }
   }
}
