/*
 *  ==================================================================
 *  DemoMediator.java: Build and exercise a mediator application.
 * 
 *  Written by: Mark Austin                               October 2012 
 *  ==================================================================
 */

package mediator01;

public class DemoMediator {
   public static void main(String[] args) {

      // Create application mediator ....

      ApplicationMediator mediator = new ApplicationMediator(); 

      // Create colleagues ....
      
      AbstractColleague desktop01 = new DesktopColleague(mediator);
      desktop01.setName("iMac");
      AbstractColleague desktop02 = new DesktopColleague(mediator);
      desktop02.setName("PC");
      AbstractColleague  mobile01 = new MobileColleague(mediator);
      mobile01.setName("iPhone");
      AbstractColleague  mobile02 = new MobileColleague(mediator);
      mobile02.setName("BMW");

      // Register colleagues with the application mediator ..
     
      mediator.addColleague(desktop01);
      mediator.addColleague(desktop02);
      mediator.addColleague(mobile01);
      mediator.addColleague(mobile02);

      // Desktop 01 sends a message to his colleagues ...

      System.out.println("");
      System.out.println("Desktop iMac sends a message ... ");
      System.out.println("==========================================");

      desktop01.send("Hello World from iMac ...");

      System.out.println("==========================================");

      // Mobile iPhone sends a message to his colleagues ...

      System.out.println("");
      System.out.println("Mobile iPhone sends a message ... ");
      System.out.println("==========================================");

      mobile01.send("Hello from iPhone ..."); 

      System.out.println("==========================================");
  }
}
