/**
 * ==============================================================
 * CircleApplication.java: Demonstrate MVC with JavaFX ....
 * ==============================================================
 */

package mvc03;

import javafx.application.Application;
import javafx.scene.Scene;
import javafx.stage.Stage;
import mvc03.controller.MainController;
import mvc03.model.MainModel;
import mvc03.view.MainView;

public class CircleApplication extends Application {

    public static void main(String[] args) {
        launch(args);
    }

    public void start(Stage primaryStage) throws Exception {

       // Assemble model-view-controller ...

       MainModel model = new MainModel();
       MainController controller = new MainController(primaryStage, model);
       MainView view = new MainView(model, controller);

       // Create and display JavaFX scene ....

       Scene scene = new Scene(view, 500, 500);
       primaryStage.setTitle("Sample JavaFx MVC APP");
       primaryStage.setScene(scene);
       primaryStage.show();
    }
}
