/**
 * ==============================================================
 * Created by fp on 26.02.17.
 * ==============================================================
 */

package mvc03.view;

import javafx.scene.layout.StackPane;

import mvc03.controller.MainController;
import mvc03.model.MainModel;

public class MainView extends StackPane {
    private final MainModel model;
    private final MainController controller;

    public MainView(MainModel model, MainController controller) {
        this.model      = model;
        this.controller = controller;

        CirclePane circleView = new CirclePane(model.getCircleModel(), controller.getCircleController());
        this.getChildren().add(circleView);

        createListeners();
    }

    private void createListeners() {
        this.setOnMouseMoved( e -> controller.getCircleController().mousePosChanged(e) );
    }
}
