/*
 *  ==========================================================================
 *  LightWatcher.java: A light watcher implements the LightListener interface.
 *  ==========================================================================
 */

package observer03;

public class LightWatcher implements LightListener {
   int id;

   public LightWatcher (int id) {
      this.id = id;
      System.out.printf("Create LightWatcher %s\n", id );
   }

   // Implementation of event handlers

   public void lightTurnedOn(LightEvent evt) {
      System.out.printf("LightWatcher %d: I am notified that light is on\n", id );
   }

   public void lightTurnedOff(LightEvent evt) {
      System.out.printf("LightWatcher %d: I am notified that light is off\n", id );
   }
}
