/*
 *  =============================================================
 *  TestLight.java: Create one light and three light watchers ...
 *  =============================================================
 */

package observer03;

public class TestLight {
   public static void main(String[] args) {
      Light light = new Light();

      LightWatcher lw1 = new LightWatcher(1);
      LightWatcher lw2 = new LightWatcher(2);
      LightWatcher lw3 = new LightWatcher(3);

      // Lightwatchers lw1 and lw2 watch the light ...

      light.addLightListener(lw1);
      light.addLightListener(lw2);
      light.turnOn();

      // Lightwatchers lw3 watches the light ...

      light.addLightListener(lw3);
      light.turnOff();

      // Lightwatchers lw2 and lw3 no longer watch the light ...

      light.removeLightListener(lw2);
      light.removeLightListener(lw3);
      light.turnOn();
   }
}
