/*
 *  ============================================================
 *  Interval.java: An Interval listener class
 *  ============================================================
 */

package observer04;

import java.lang.Math;

public class Interval implements NodeListener {
   Node end1, end2;
   double length;
   int id;

   // Constructor methods ...

   public Interval (int id) {
      this.id = id;
      System.out.println("Interval-0" + id + ": created");
   }

   public Interval (int id, Node end1, Node end2 ) {
      this.id   =   id;
      this.end1 = end1;
      this.end2 = end2;
      setLength();
   }

   // Compute length of interval 

   public void setLength() {
      length = Math.abs( end1.getX() - end2.getX() );
   }

   public double getLength() {
      return length;
   }

   // String description of the interval ...

   public String toString() {
      String s = "Interval: id = " + id + " length = " + length; 
      return s;
   }

   // Implementation of event handlers

   public void nodeMoved( NodeEvent evt ) {
      setLength();
      System.out.println(" Interval-0" + id + ": New length = " + length );
   }
}
