/*  
 *  ============================================================================
 *  ToggleButton.java: Simulate behavior of a button implemented as an active
 *  object. State behavior is defined as follows:
 * 
 *      Event State  --> push 
 *      ---------------------
 *               ON  -->  OFF 
 *              OFF  -->   ON
 *      ---------------------
 * 
 *  Simulation: The button is pushed five times.
 * 
 *  Written by: Mark Austin                                            July 2009
 *  ============================================================================
 */  

package state01;
                           
public class ToggleButton {
   public static void main( String[] args ) {
      Button power = new Button();
      for ( int i = 1; i <= 5; i = i + 1 )
         power.push();
   }
}
