/**
 *  ========================================================================
 *  RunPattern.java: Exercise strategy design pattern example.
 * 
 *  This example is a minor improvement of the Java Strategy Design Pattern
 *  example on wikipedia at: http://en.wikipedia.org/wiki/Strategy_pattern
 *  ========================================================================
 */

package strategy01;

public class RunPattern {
   public static void main(String[] args) {
      Context context;

      // Demonstration for selection of different strategies

      context = new Context();
      context.setAddStrategy();
      int resultA = context.execute(3, 4);

      context = new Context();
      context.setMultiplyStrategy();
      int resultB = context.execute(3, 4);

      context = new Context();
      context.setSubtractStrategy();
      int resultC = context.execute(3, 4);
   }
}

