/*
 *  ====================================================================
 *  TestVisitorPattern.java: Exercise the visitor design pattern ...
 *
 *  Modified by: Mark Austin                                  June, 2012
 *  ====================================================================
 */

package visitor01;
 
public class TestVisitorPattern {
    public static void main(String[] args) {
        Car car = new Car();

        System.out.println("" );
        System.out.println("Visit Car: Print Elements    " );
        System.out.println("=============================" );

        car.accept( new CarPrintVisitor() );

        System.out.println("" );
        System.out.println("Visit Car: Draw Elements     " );
        System.out.println("=============================" );

        car.accept( new CarDrawVisitor() );

        // Compute and print total cost of the car ...

        System.out.println("" );
        System.out.println("Visit Car: Economic Analysis " );
        System.out.println("=============================" );

        CarPriceVisitor cpv = new CarPriceVisitor();
        car.accept( cpv );

        System.out.println("=============================" );
        System.out.printf( "Total cost    = %6.2f\n", cpv.getTotalPrice() );
        System.out.println("=============================" );
    }
}
