/*
 *  ======================================================================
 *  CompositePriceVisitor.java: Visit scene elements and compute price ...
 *
 *  Modified by: Mark Austin                                    June, 2012
 *  ======================================================================
 */

package visitor03.model;

import visitor03.model.*;
import visitor03.model.compound.*;
 
public class CompositePriceVisitor implements FeatureElementVisitor {
   private double totalPrice;    

   public void visit(       Tree   tree ) {
      System.out.printf("Price:  tree = %10.2f\n", tree.getPrice() );
      totalPrice += tree.getPrice();
   }

   public void visit(   CarModel    car ) {
      System.out.printf("Price:   car = %10.2f\n", car.getPrice() );
      totalPrice += car.getPrice();
   }

   public void visit( HouseModel  house ) {
      System.out.printf("Price: house = %10.2f\n", house.getPrice() );
      totalPrice += house.getPrice();
   }

   public void visit( AbstractFeature feature ) {}
   public void visit( CompositeHierarchy composite ) {}
   public void start( CompositeHierarchy composite ) {}
   public void finish( CompositeHierarchy composite ) {}

   // Return the internal state ....

   public double getTotalPrice() {
      return totalPrice;   
   }
}
