/*
 * ================================================================
 * BillingVisitor.java: Compute price of items in shopping cart ...
 * ================================================================
 */

package visitor04;

public class BillingVisitor implements Visitor {
   private double totalPrice = 0.0;

   // Visit items and compute price ...

   @Override
   public void visit( Book book ) {
      totalPrice += ( book.getQuantity() * book.getPrice() );
   }

   @Override
   public void visit( Vegetable vegetable ) {
      totalPrice += ( vegetable.getWeight() * vegetable.getPrice() );
   }

   @Override
   public void visit(Fruit fruit) {
      totalPrice += ( fruit.getQuantity() * fruit.getPrice() );
   }

   // Retrieve the internal state ...

   public double getTotalPrice() {
      return totalPrice;
   }
}
